#pragma once

#include"fixed.h"
#include"greedy.h"
#include"single.h"
#include"preference.h"
#include"rnd.h"
#include"xor.h"
#include"mult_phase.h"
#include<cstdio>
#include<string>
#include<cassert>

adversary* create_adversary(FILE* fin)
{
    auto ri = [&fin]()
              {
                  int x;
                  assert(fscanf(fin, "%d", &x) == 1);
                  return x;
              };

    char buffer[128];
    assert(fscanf(fin, "%s", buffer) == 1);
    string type = buffer;
    
    if(type == "fixed")       { return new fixed_adversary(ri(), ri());                }
    else if(type == "greedy") { return new greedy_adversary(ri());                     }
    else if(type == "single") { return new single_adversary(ri());                     }
    else if(type == "prefer") { return new preference_adversary(ri(), ri());           }
    else if(type == "rnd")    { return new rnd_adversary(ri());                        }
    else if(type == "close")  { return new xor_adversary(0, ri());                     }
    else if(type == "diff")   { return new xor_adversary(1, ri());                     }
    else if(type == "multi")  { return new multiple_phase_adversary(ri(), ri(), ri()); }
    else                      { throw "invalid input";                                 }
}
