#pragma once

#include"base.h"
#include<cstdio>
#include<algorithm>
#include<cassert>

class offline_adversary : public adversary
{
 public:   
    void send(vector<int> locations)
    {
        queries.push_back(locations);
    }

    vector<int> wait()
    {
        vector<int> result = get_replies(queries);

        assert(result.size() == queries.size());

        queries.clear();
        return result;
    }

 protected:
    virtual vector<int> get_replies(vector<vector<int>>) = 0;
    
 private:
    vector<vector<int>> queries;
};
