#include <cstdio>
#include <cstdlib>
#include <cassert>
#include "avoid.h"

using namespace std;

namespace {
    constexpr int SEND = 114738923,
                  WAIT = 752019792,
                ANSWER = 539014118;
    constexpr size_t N = 1000;

    template<typename T> void write(T t) {
        fwrite(&t, sizeof(t), 1, stdout);
        fflush(stdout);
    }

    template<typename T> T read_or_exit() {
        T x;
        if(fread(&x, sizeof(x), 1, stdin) != 1) exit(0);
        return x;
    }

    int read_int_or_exit() {
        int x = read_or_exit<int>();
        if(x == -1) exit(0);
        return x;
    }

    void answer(pair<int, int> ans) {
        write(ANSWER); write(ans.first); write(ans.second);
    }
}

void send(vector<int> positions) {
    write(SEND);
    read_int_or_exit();

    if(positions.size() > N)
        write(-1), exit(0);
    write(static_cast<int>(positions.size()));

    vector<short> compressed; compressed.reserve(positions.size());
    for(int x : positions)
        compressed.push_back(static_cast<short>(x < -1 or x > 2000? -1 : x));

    if(fwrite(compressed.data(), sizeof(short), compressed.size(), stdout) != compressed.size())
        exit(0);
    fflush(stdout);
    read_int_or_exit();
}

vector<int> wait() {
    write(WAIT);

    int k = read_int_or_exit();
    vector<int> answers(k);
    if(fread(answers.data(), sizeof(int), answers.size(), stdin) != answers.size()) exit(0);
    return answers;
}

int main() {
    int R = read_int_or_exit(), H = read_int_or_exit();
    answer(scout(R, H));
}
